
$path = ".";
$Database_dir = '../Databases';

require "LKBinDB.pl";
require "LKSQL.pl";
require "File.pl";

print "Welcome to LKBinDB example!\n";

$CurrDB = '';


while (1) {
	&Menu;
	print ">";
	chomp($cmd = <STDIN>);
	($i) = ($cmd =~ /\s*(\d+)\s*/);
	$func = "CMD$i";
	eval {&$func;};
};	


#------------------------------------------------------------------------
sub	CMD0 { exit; };
#------------------------------------------------------------------------
sub	CMD1 {
	@f = <./$Database_dir/*>;
	print "\n" . '-' x 20 . "\n";
	print "DATABASES LIST:\n";
	foreach (@f) {
		if (-d){
			(my $n = $_) =~ s/.\/\Q$Database_dir\E\///i;
			print "\t$n\n";
		};
	};
	print '-' x 20 . "\n";
};
#------------------------------------------------------------------------
sub	CMD2 {
	print "\n" . '-' x 20 . "\n";
	print "CREATE DATABASE:\nType Name:\n";
	chomp(my $n = <STDIN>);
	
	$_ = &CreateDB($n);
	C{
		if (/1/){ print "OK!\n"; last C; };
		if (/0/){ print "can't create!\n"; last C; };
		if (/-1/){ print "already exist!\n"; last C; };
		if (/-2/){ print "wrong name!\n"; last C; };
	};
	
	print '-' x 20 . "\n";
};
#------------------------------------------------------------------------
sub	CMD3 {
	print "\n" . '-' x 20 . "\n";
	print "DROP DATABASE:\nType Name:\n";
	chomp(my $n = <STDIN>);
	
	$_ = &DropDB($n);
	C{
		if (/1/){ print "OK!\n"; last C; };
		if (/0/){ print "can't drop!\n"; last C; };
		if (/-1/){ print "Partially Dropped!\n"; last C; };
		if (/-2/){ print "wrong name!\n"; last C; };
	};
	
	print '-' x 20 . "\n";
};
#------------------------------------------------------------------------
sub	CMD4 {
	print "\n" . '-' x 20 . "\n";
	print "Current DATABASE:$CurrDB\nSelect New Name (empty to skip):\n";
	
	chomp(my $n = <STDIN>);
	if ($n) {
		$CurrDB = $n if -e "$path/$Database_dir/$n/$n.lkdb";
	};
	
	print "Current DATABASE:$CurrDB\n";
	print '-' x 20 . "\n";
};
#------------------------------------------------------------------------
sub	CMD5 {
	print "\n" . '-' x 20 . "\n";
	print "Current DATABASE:$CurrDB\nTables:\n";
	
	my $f = &ReadFile("$path/$Database_dir/$CurrDB/$CurrDB.lkdb");
	
	foreach ( split(/,/, $f) ) {
		print "\t$_\n";
	};
	
	print '-' x 20 . "\n";	
};
#------------------------------------------------------------------------
sub	CMD6 {
	print "\n" . '-' x 20 . "\n";
	print "Current DATABASE:$CurrDB\nMk Table Name (empty to skip):\n";
	
	chomp(my $n = <STDIN>);
	if ($n) {
		print "Type Fields (separated by comma)\n";
		chomp(my $f = <STDIN>);
		$_ = &CreateTable($CurrDB, $n, [split(/,/, $f)]);
		
		C{
			if (/1/){ print "OK!\n"; last C; };
			if (/0/){ print "can't create!\n"; last C; };
			if (/-1/){ print "already exists!\n"; last C; };
			if (/-2/){ print "wrong name!\n"; last C; };
		};
		
	};
	
	print '-' x 20 . "\n";
};
#------------------------------------------------------------------------
sub	CMD7 {
	print "\n" . '-' x 20 . "\n";
	print "Current DATABASE:$CurrDB\nDrop Table Name (empty to skip):\n";
	
	chomp(my $n = <STDIN>);
	if ($n) {		
		$_ = &DropTable($CurrDB, $n);
		
		C{
			if (/1/){ print "OK!\n"; last C; };
			if (/0/){ print "can't drop!\n"; last C; };
		};		
	};
	
	print '-' x 20 . "\n";
};
#------------------------------------------------------------------------
sub	CMD8 {
	print "\n" . '-' x 20 . "\n";
	print "Current DATABASE:$CurrDB\nBrowse Table Name:\n";
	
	chomp(my $n = <STDIN>);
	
	my $db = New LKDatabase($CurrDB);

	$db->Open($n) || goto E;
	
	&ListTable($db);
	
	$db->Close;
	goto EN;
	E:
		print "Table not found ${n}!\n";
	EN:	
	print '-' x 20 . "\n";
};
#------------------------------------------------------------------------
sub CMD9 {
	print "\n" . '-' x 20 . "\n";
	print "Current DATABASE:$CurrDB\nQuery:\n";
	
	chomp(my $n = <STDIN>);
	my $db = New LKDatabase($CurrDB);
	my $db1 = $db->Query($n);
	&ListTable($db1);
	$db1->Close;
	print '-' x 20 . "\n";
};
#------------------------------------------------------------------------
#------------------------------------------------------------------------
#------------------------------------------------------------------------
#------------------------------------------------------------------------
sub	ListTable ($;) {
	my ($d) = @_;
	
	sub	G {
		if (length($_[0]) > 9) { return substr($_[0], 0 ,9); };
		return $_[0];
	};
	
	print "\n" . '-' x 30 . "\n";
	foreach ( @{$d->{Fields}} ) {
		print &G($_) . '|';
	};
	print "\n" . '-' x 30 . "\n";
	
	$d->First;
	do {
		foreach ( @{$d->{Fields}} ) {
			print &G($d->{FieldByName}->{$_}) . '|';
		};
		print "\n";
	} while $d->Next;
			
};
#------------------------------------------------------------------------

sub	Menu {
	print "\n" . '-' x 20 . "\n";
	
	print q^
		0 - Exit
		1 - List of Databases
		2 - Create Database
		3 - Drop Database
		4 - Select DB
		5 - List Tables
		6 - Mk Table
		7 - Drop Table
		8 - Browse Table
		9 - Exec Query
	^;
	
	print "\n" . '-' x 20 . "\n";
};	

1;