require "$path/File.pl";
require "$path/LKBinTbl.pl";
$Database_dir = 'Databases' unless defined $Database_dir;
sub	CreateDB {
my ($DbName) = @_;
return -2 if $DbName =~ /(?:[\|\/\\]|\.\.)/i;
return 0 if !$DbName;
return -1 if -e "$path/$Database_dir/$DbName/$DbName.lkdb";
if (!-e "$path/$Database_dir/$DbName"){
mkdir("$path/$Database_dir/$DbName", 0777) || return 0;
};
open(DB, ">$path/$Database_dir/$DbName/$DbName.lkdb") || return 0;
close(DB);
return 1;
};
sub	DropDB {
my ($DbName) = @_;
return -2 if $DbName =~ /(?:[\|\/\\]|\.\.)/i;
return 0 if !$DbName;
return 0 if !-e "$path/$Database_dir/$DbName/$DbName.lkdb";
my $Fields;
eval {
&ReadFile("$path/$Database_dir/$DbName/$DbName.lkdb", \$Fields, 1);
};
return 0 if $@;
my @Tbls = split(/\,/, $Fields);	
my $res = 1;
unlink "$path/$Database_dir/$DbName/$DbName.lkdb" || ($res = 0);
foreach my $TblName (@Tbls) {
unlink "$path/$Database_dir/$DbName/$TblName.def" || ($res = 0);
unlink "$path/$Database_dir/$DbName/$TblName.tbl" || ($res = 0);
unlink "$path/$Database_dir/$DbName/$TblName.tbld" || ($res = 0);
};
rmdir("$path/$Database_dir/$DbName");	# not to check on success
return $res;
};
sub	CreateTable {
my ($DbName, $TblName, $Fields) = @_;
return 0 if !$DbName || !$TblName || !scalar @{$Fields};
return -2 if $DbName =~ /(?:[\|\/\\]|\.\.)/i || $TblName =~ /(?:[\|\/\\\\,]|\.\.)/i;
return -1 if -e "$path/$Database_dir/$DbName/$TblName.def";
my $Def_data;
my %Unique = map { $_ => 1 } @{$Fields};
$Def_data .= join(',', keys %Unique) . ',';
$Def_data =~ s/\,\,/\,/g;
$Def_data =~ s/^\,//g;
&WriteFile("$path/$Database_dir/$DbName/$TblName.def", \$Def_data ) || goto DelTbl;
&WriteFile("$path/$Database_dir/$DbName/$TblName.tbl") || goto DelTbl;
&WriteFile("$path/$Database_dir/$DbName/$TblName.tbld") || goto DelTbl;
&LockFile("$path/$Database_dir/$DbName/$DbName.lkdb.lock");
open(DB, ">>$path/$Database_dir/$DbName/$DbName.lkdb") || goto DelTbl;
flock(FILE, 2) if $Use_flock;
print DB "$TblName,";
flock(FILE, 8) if $Use_flock;
close(DB);
&UnLockFile("$path/$Database_dir/$DbName/$DbName.lkdb.lock");
return 1;
DelTbl:
unlink "$path/$Database_dir/$DbName/$TblName.def";
unlink "$path/$Database_dir/$DbName/$TblName.tbl";
unlink "$path/$Database_dir/$DbName/$TblName.tbld";
return 0;
};
sub	DropTable {
my ($DbName, $TblName) = @_;
&LockFile("$path/$Database_dir/$DbName/$DbName.lkdb.lock");	
open(DB, "<$path/$Database_dir/$DbName/$DbName.lkdb");
flock(DB, 2) if $Use_flock;
my %tbls = map {$_ => ''} split(/,/, <DB>);
flock(DB, 8) if $Use_flock;
close(DB);
goto Err unless defined $tbls{$TblName};
delete $tbls{$TblName};
open(DB, ">$path/$Database_dir/$DbName/$DbName.lkdb");
flock(DB, 2) if $Use_flock;
my $tbls_str = join(',', keys %tbls);
$tbls_str .= ',' if $tbls_str !~ /,$/;
$tbls_str = '' if $tbls_str eq ',';	# clear if empty
print DB $tbls_str;
flock(DB, 8) if $Use_flock;
close(DB);	
&UnLockFile("$path/$Database_dir/$DbName/$DbName.lkdb.lock");
&LockFile("$path/$Database_dir/$DbName/$TblName.tbl.lock");	
unlink "$path/$Database_dir/$DbName/$TblName.def" || goto Err;
unlink "$path/$Database_dir/$DbName/$TblName.tbl" || goto Err;
unlink "$path/$Database_dir/$DbName/$TblName.tbld" || goto Err;	
&UnLockFile("$path/$Database_dir/$DbName/$TblName.tbl.lock");
return 1;	
Err:
&UnLockFile("$path/$Database_dir/$DbName/$TblName.tbl.lock");	
&UnLockFile("$path/$Database_dir/$DbName/$DbName.lkdb.lock");
return 0;
};
sub	AddFieldsToTable {
my ($DbName, $TblName, $Fields) = @_;
};
sub GetVersionNumber {
return $LKDatabase::__VERSION__;
};
1;