require "$path/File.pl";
require "$path/BinFunctions.pl";
require "$path/GenFunc.pl";		#	EvalCode used
package LKDatabase;
$__VERSION__ = '1.0 DEMO';
use Fcntl qw( O_RDWR O_CREAT O_TRUNC );
$Database_dir ||= $::Database_dir ||= 'Databases';
$path ||= $::path ||= '.';
sub New	{
my ($Class, $DBName) = @_;
return '' if !-e "$path/$Database_dir/$DBName/$DBName.lkdb";
my $self = {
'IsOpen' => '',
'DB' => $DBName,
'Table' => '',
'TBL' => '',
'TBLD' => '',
'State' => '',
'Fields' => [],
'FieldByName' => {},
'ParseFieldByName' => {},
'RecordCount' => '',
'DeletedCount' => '',
'ERRORS' => [],
'CurrIndx' => '',
'IsTemp' => 0,
'OnBeforeAppend' => '',
'OnBeforeEdit' => '',
'OnBeforePost' => '',
'OnBeforeFirst' => '',
'OnBeforeLast' => '',
'OnBeforePrior' => '',
'OnBeforeNext' => '',
'OnBeforeDelete' => '',
'OnAfterAppend' => '',
'OnAfterEdit' => '',
'OnAfterPost' => '',
'OnAfterFirst' => '',
'OnAfterLast' => '',
'OnAfterPrior' => '',
'OnAfterNext' => '',
'OnAfterDelete' => '',
};
bless $self, $Class;
return $self;
};
sub _ERROR {
my ($self, $MSG) = @_;
push ( @{$self->{'ERRORS'}}, $MSG);
return 0;
};
sub Open {
my ($self, $TblName) = @_;
return $self->_ERROR("Can't open table '$TblName', table already opened.") if $self->{IsOpen};
return (-1 + $self->_ERROR("Can't open table '$TblName', table not exist.")) if !-e "$path/$Database_dir/$self->{DB}/$TblName.tbl" || !-e "$path/$Database_dir/$self->{DB}/$TblName.tbld" || !-e "$path/$Database_dir/$self->{DB}/$TblName.def";
&main::LockFile("$path/$Database_dir/$self->{DB}/$TblName.tbl.lock");
&main::LockFile("$path/$Database_dir/$self->{DB}/$TblName.tbld.lock");
&main::LockFile("$path/$Database_dir/$self->{DB}/$TblName.def.lock");
if (!open(DEF, "<$path/$Database_dir/$self->{DB}/$TblName.def")){
$self->Close;
return $self->_ERROR("Can't open table '$TblName', error message: ${!}.");
};
chomp(my $Fields = <DEF>);
close(DEF);
$self->{Fields} = [split(/\,/, $Fields)];
foreach my $fld_name (@{$self->{Fields}}){
$self->{ParseFieldByName}->{$fld_name} = 1;
};
local (*TBL, *TBLD);
if (!sysopen(TBL, "$path/$Database_dir/$self->{DB}/$TblName.tbl", O_RDWR)){
$self->Close;
return $self->_ERROR("Can't open table '$TblName' [tbl] in RW mode, error message: ${!}.");
};
binmode(TBL);
flock(TBL, 2) if $Use_flock;
$self->{TBL} = *TBL;
if (!sysopen(*TBLD, "$path/$Database_dir/$self->{DB}/$TblName.tbld", O_RDWR)){
$self->Close;
return $self->_ERROR("Can't open table '$TblName' [tbld] in RW mode, error message: ${!}.");
};
binmode(TBLD);
flock(TBLD, 2) if $Use_flock;
$self->{TBLD} = *TBLD;
$self->{IsOpen} = 1;
$self->{State} = 'Browse';
$self->{Table} = $TblName;
$self->{'ERRORS'} = []; # clear errors
$self->RecordCount(1);	# recount records, read deleted records
$self->First;
return 1;
};
sub	Close {
my ($self) = @_;
return $self->_ERROR("Can't close table '$self->{Table}', table not opened.") unless $self->{IsOpen};
return $self->_ERROR("Can't close table '$self->{Table}', table not properly opened.") if !$self->{IsOpen} || !$self->{TBL} || !$self->{TBLD};
sysseek($self->{TBL}, 0, 2);
my $Fields_count = scalar @{$self->{Fields}};
my $FileSize = sysseek($self->{TBL}, 0, 1);
$FileSize = 0 if $FileSize < 0;	# -1
my $rec_count = int( $FileSize / ((8*$Fields_count)+1) ) - $self->{RecordCount};
flock($self->{TBL}, 8) if $Use_flock;
close($self->{TBL});
$self->{TBL} = '';
&main::UnLockFile("$path/$Database_dir/$self->{DB}/$self->{Table}.tbl.lock");
flock($self->{TBLD}, 8) if $Use_flock;
close($self->{TBLD});
$self->{TBLD} = '';
&main::UnLockFile("$path/$Database_dir/$self->{DB}/$self->{Table}.tbld.lock");
&main::UnLockFile("$path/$Database_dir/$self->{DB}/$self->{Table}.def.lock");
&main::LockFile("$path/$Database_dir/$self->{DB}/$self->{Table}.def.lock");
open(DEF, "<$path/$Database_dir/$self->{DB}/$self->{Table}.def");
flock(DEF, 2) if $Use_flock;
chomp(my $Fileds_def = <DEF>);	#skip filds def
flock(DEF, 8) if $Use_flock;
close(DEF);
open(DEF, ">$path/$Database_dir/$self->{DB}/$self->{Table}.def");
flock(DEF, 2) if $Use_flock;
print DEF "$Fileds_def\n$rec_count";
flock(DEF, 8) if $Use_flock;
close(DEF);
&main::UnLockFile("$path/$Database_dir/$self->{DB}/$self->{Table}.def.lock");
$self->{IsOpen} = 0;
$self->{State} = '';
$self->{RecordCount} = 0;
if ($self->{IsTemp}){
&::DropTable($self->{DB}, $self->{Table}) || return $self->_ERROR("Can't close temporary table '$self->{Table}', an error in &::DropTable(...) occured.");
};
$self->{IsTemp} = 0;
return 1;
};
sub	Append {
my ($self) = @_;
return $self->_ERROR("Can't Append record, table '$self->{Table}' not opened.") unless $self->{IsOpen};
return $self->_ERROR("Can't Append record, table '$self->{Table}' must be in 'Browse' state, instead of '$self->{State}'") if $self->{State} ne 'Browse';
unless (&::EvalCode($self->{'OnBeforeAppend'})) { return $self->_ERROR("Can't Append record, error executing 'OnBeforeAppend' event."); };
$self->{State} = 'Append';
&::EvalCode($self->{'OnAfterAppend'});
return 1;
};
sub	Cancel {
my ($self) = @_;
return $self->_ERROR("Can't Cancel operation, table '$self->{Table}' not opened.") unless $self->{IsOpen};
return $self->_ERROR("Can't Cancel operation, table '$self->{Table}' in idle state.") if $self->{State} eq 'Browse';
$self->{State} = 'Browse';
return $self->ReadRec;
};
sub	Post {
my ($self) = @_;
return $self->_ERROR("Can't Post record, table '$self->{Table}' not opened.") unless $self->{IsOpen};
unless (&::EvalCode($self->{'OnBeforePost'})) { return $self->_ERROR("Can't Post record, error executing 'OnBeforePost' event."); };
my $res = 0;
if ($self->{State} eq 'Append'){
$res = $self->AppendPost;
}
elsif ($self->{State} eq 'Edit'){
$res = $self->EditPost;
};
$self->{State} = 'Browse';
&::EvalCode($self->{'OnAfterPost'});
return $res;
};
sub	EditPost {
my ($self) = @_;
my $buff;
my $Fields_count = scalar @{$self->{Fields}};
my $posit = $self->{CurrIndx}*(($Fields_count * 8) + 1);
sysseek($self->{TBL}, $posit, 0);
sysread($self->{TBL}, $buff, 1); # is del
for (my $i = 0; $i < $Fields_count; $i++){
my $Data = $self->{FieldByName}->{$self->{Fields}->[$i]};
my $NewDataLength = length($Data);
sysread($self->{TBL}, $buff, 8);
$buff =~ /((?:.|\n){4})((?:.|\n){4})/;
my ($DataStart, $DataLength) = (&main::GetLongIntBySymbol($1), &main::GetLongIntBySymbol($2));
if ($DataLength >= $NewDataLength){	# we can write to this place
sysseek($self->{TBLD}, $DataStart, 0);
syswrite($self->{TBLD}, $Data);
sysseek($self->{TBL}, ($posit + 1)+($i*8), 0);	# start of rec
sysseek($self->{TBL}, 4, 1);
syswrite($self->{TBL}, &main::GetLongInt($NewDataLength));
} else {
sysseek($self->{TBLD}, 0, 2);	# end
my $StartPos = sysseek($self->{TBLD}, 0, 1);
syswrite($self->{TBLD}, $Data);
sysseek($self->{TBL}, ($posit + 1)+($i*8), 0);	# start of rec
syswrite($self->{TBL}, &main::GetLongInt($StartPos));
syswrite($self->{TBL}, &main::GetLongInt($NewDataLength));
};
};
return 1;
};
sub	AppendPost {
my ($self) = @_;
my $Fields_count = scalar @{$self->{Fields}};
sysseek($self->{TBL}, 0, 2);	# end of file
syswrite($self->{TBL}, 0); # record not deleted
for (my $i = 0; $i < $Fields_count; $i++){
sysseek($self->{TBLD}, 0, 2);	# end of file
my $StartPos = sysseek($self->{TBLD}, 0, 1);
my $Data = $self->{FieldByName}->{$self->{Fields}->[$i]};
my $Length = length($Data);
syswrite ($self->{TBLD}, $Data);
syswrite($self->{TBL}, &main::GetLongInt($StartPos));
syswrite($self->{TBL}, &main::GetLongInt($Length));
};
$self->{RecordCount}++;
return 1;
};
sub	RecordCount {
my ($self, $NeedRecount) = @_;
return $self->_ERROR("Can't count records, table '$self->{Table}' not opened.") unless $self->{IsOpen};
return $self->{RecordCount} unless $NeedRecount;
open(DEF, "<$path/$Database_dir/$self->{DB}/$self->{Table}.def");
flock(DEF, 2) if $Use_flock;
my $Fields_count = scalar @{$self->{Fields}};
sysseek($self->{TBL}, 0, 2);
my $FileSize = sysseek($self->{TBL}, 0, 1);
$FileSize = 0 if $FileSize < 0;	# -1
$rec_count = int($FileSize /( (8*$Fields_count) + 1));
<DEF>;	#skip filds def
chomp(my $DelRecords = <DEF>);
$self->{DeletedCount} = $DelRecords;
$rec_count -= $DelRecords;
flock(DEF, 8) if $Use_flock;
close(DEF);
$self->{RecordCount} = $rec_count;
return $rec_count;
};
sub	Edit {
my ($self) = @_;
return $self->_ERROR("Can't Edit record, table '$self->{Table}' not opened.") unless $self->{IsOpen};
return $self->_ERROR("Can't Edit record, table '$self->{Table}' is empty.") if $self->{RecordCount} <= 0 || $self->{CurrIndx} < 0;
return $self->_ERROR("Can't Edit record, table '$self->{Table}' must be in 'Browse' state, instead of '$self->{State}'") if $self->{State} ne 'Browse';
unless (&::EvalCode($self->{'OnBeforeEdit'})) { return $self->_ERROR("Can't Edit record, error executing 'OnBeforeEdit' event."); };
$self->{State} = 'Edit';
&::EvalCode($self->{'OnAfterEdit'});
return 1;
};
sub	First {
my ($self) = @_;
return $self->_ERROR("Can't set table to First record, table '$self->{Table}' not opened.") unless $self->{IsOpen};
unless (&::EvalCode($self->{'OnBeforeFirst'})) { return $self->_ERROR("Can't set table to First record, error executing 'OnBeforeFirst' event."); };
$self->{CurrIndx} = 0;
my $res = $self->ReadRec;
&::EvalCode($self->{'OnAfterFirst'});
return $res;
};
sub	ReadRec {
my ($self) = @_;
return $self->_ERROR("Can't read record data [tbl], table '$self->{Table}' not opened.") unless $self->{IsOpen};
return $self->_ERROR("Can't read record data [tbl], table '$self->{Table}' is empty.") if $self->{RecordCount} <= 0 || $self->{CurrIndx} < 0;
Start:
my $buff = '';
my $Fields_count = scalar @{$self->{Fields}};
my $posit = $self->{CurrIndx}*(($Fields_count * 8) + 1);
sysseek($self->{TBL}, $posit, 0);
sysread($self->{TBL}, $buff, 1);
if ($buff){ # deleted
return $self->_ERROR("Can't read record data [tbl], table '$self->{Table}' is corrupted.") if $self->{CurrIndx} >= $self->{RecordCount} - 1 + $self->{DeletedCount};
$self->{CurrIndx}++;
goto Start;
};
for (my $i=0; $i < $Fields_count; $i++){
if (!$self->{ParseFieldByName}->{$self->{Fields}->[$i]}) {
sysseek($self->{TBL}, 8, 1);
$self->{FieldByName}->{$self->{Fields}->[$i]} = '';	#clear prev data
next;
};
sysread($self->{TBL}, $buff, 8);	# read record
$buff =~ /((?:.|\n){4})((?:.|\n){4})/;
my ($DataStart, $DataLength) = (&main::GetLongIntBySymbol($1), &main::GetLongIntBySymbol($2));
$self->{FieldByName}->{$self->{Fields}->[$i]} = $self->ReadTBLD($DataStart, $DataLength);
};
return 1;
};
sub	ReadTBLD {
my ($self, $StartPos, $DataLength) = @_;
return $self->_ERROR("Can't read record data [tbld], table '$self->{Table}' not opened.") unless $self->{IsOpen};
sysseek($self->{TBLD}, $StartPos, 0);
sysread($self->{TBLD}, my $buff, $DataLength);
return $buff;
};
sub	Next {
my ($self) = @_;
return $self->_ERROR("Can't set table to Next record, table '$self->{Table}' not opened.") unless $self->{IsOpen};
return 0 if ( $self->{CurrIndx} >= $self->{RecordCount} - 1 + $self->{DeletedCount} );		
unless (&::EvalCode($self->{'OnBeforeNext'})) { return $self->_ERROR("Can't set table to Next record, error executing 'OnBeforeNext' event."); };
$self->{CurrIndx}++;
my $res = $self->ReadRec;
&::EvalCode($self->{'OnAfterNext'});
return $res;
};
sub	Prior {
my ($self) = @_;
return $self->_ERROR("Can't set table to Prior record, table '$self->{Table}' not opened.") unless $self->{IsOpen};
return 0 if $self->{CurrIndx} <= 0;
unless (&::EvalCode($self->{'OnBeforePrior'})) { return $self->_ERROR("Can't set table to Prior record, error executing 'OnBeforePrior' event."); };
$self->{CurrIndx}--;
my $res = $self->ReadRec;
&::EvalCode($self->{'OnAfterPrior'});
return $res;
};
sub	Last {
my ($self) = @_;
return $self->_ERROR("Can't set table to Last record, table '$self->{Table}' not opened.") unless $self->{IsOpen};
unless (&::EvalCode($self->{'OnBeforeLast'})) { return $self->_ERROR("Can't set table to Last record, error executing 'OnBeforeLast' event."); };
$self->{CurrIndx} = $self->{RecordCount} - 1 + $self->{DeletedCount};
my $res = $self->ReadRec;
&::EvalCode($self->{'OnAfterLast'});
return $res;
};
sub	Delete {
my ($self, $ReadRec) = @_;
return $self->_ERROR("Can't Delete record, table '$self->{Table}' not opened.") unless $self->{IsOpen};
return $self->_ERROR("Can't delete record, table '$self->{Table}' is empty.") if $self->{RecordCount} <= 0 || $self->{CurrIndx} < 0;
unless (&::EvalCode($self->{'OnBeforeDelete'})) { return $self->_ERROR("Can't Delete record, error executing 'OnBeforeDelete' event."); };
$ReadRec = 1 unless defined $ReadRec;
my $Fields_count = scalar @{$self->{Fields}};
my $posit = $self->{CurrIndx}*(($Fields_count * 8) + 1);
sysseek($self->{TBL}, $posit, 0);
syswrite($self->{TBL}, 1);
$self->{RecordCount}--;
$self->{DeletedCount}++;
&::EvalCode($self->{'OnAfterDelete'});
return $self->ReadRec if $ReadRec;
return 1;
};
sub	Empty {
my ($self) = @_;
return $self->_ERROR("Can't Empty table, table '$self->{Table}' not opened.") unless $self->{IsOpen};
truncate($self->{TBL}, 0) || return $self->_ERROR("Can't Empty table '$self->{Table}', error while 'truncate [tbl]' .");
truncate($self->{TBLD}, 0) || return $self->_ERROR("Can't Empty table '$self->{Table}', error while 'truncate [tbld]' .");
$self->{RecordCount} = 0;
$self->{CurrIndx} = 0;
$self->{FieldByName} = {};
return 1;
};
1;
