
require "$path/Templates.pl";

sub	Action_main {	
	$::DataBasesDir = 'Databases';
	$Database_dir = "../$::DataBasesDir"; # for BinDb
	require "$path/LKBinDB.pl";
	require "$path/LKSQL.pl";

	my $dbList = &GetDbList;
	my $data = &GetMainData;
	my $TblList = &GetTblList;	
	
	&FP('main', { 'DBLIST' => $dbList, 'TBLLIST' => $TblList, 'DATA' => $data, } );
};


sub	GetDbList {
	opendir(D, "$path/../$::DataBasesDir");
	my @F = readdir(D);
	closedir(D);
	
	my ($dbl, @D);
	
	foreach (@F){
		next if /^\.\.?$/;
		push(@D, $_);
	};
	@F = undef;
	
	foreach (@D){
		$dbl .= qq!<a href="action.cgi?db=$_">$_</a><br>!;
	};
	
	$dbl = '<b>Databases:<br>' . '&nbsp;' x 5 . 'Current:' . ($in{db} ? $in{db} : '&ltno&gt') . '<hr>' . $dbl . '</b>';
	$dbl .= '<hr><a href=action.cgi?q=createdb>Create DB</a>';
	
	return $dbl;
};


sub	GetTblList {
	my $db = $in{db} || return '';
	
	my $f = "$path/../$::DataBasesDir/$db/$db.lkdb";
	return '' if !-e $f;
	my $tbls = &ReadFile($f);
	
	my $d = qq^
		<a href="action.cgi?q=dropdb&db=$db" onClick="return confirm('Are you sure you want to drop this database?')">Drop Database ($in{db})</a><hr>
	^;
	
	$tbls = [split(/,/, $tbls)];
	$d .= 'Tables:<br>';
	foreach (@{$tbls}){
		$_ = qq^<a href="action.cgi?q=edittbl&tbl=$_&db=$db">$_</a>^;
	};
	
	$d .= join('<br>', @{$tbls});
	
	$d .= qq^
		<br><hr>
		<a href="action.cgi?q=createtbl&db=$in{db}">Create Table</a><br>
		<a href="action.cgi?q=execquery&db=$in{db}">Execute Query</a>
	^;
	
	return $d;
};


sub GetMainData {

	my $res;

	if ($in{q} eq 'createdb') {
	
		$res = q^
			<center><b>Create database</b></center><br><hr>
			<form action="action.cgi" method="post">
				Db Name:<br>
				<input type="hidden" name="q" value="createdb2">
				<input type="text" name="db">
				<input type="Submit">
			</form>
		^;
		
	}
	elsif ($in{q} eq 'createdb2') {
		&CreateDB($in{db}) if $in{db};
		print "Location: action.cgi?db=$in{db}\n\n";
	}
	elsif ($in{q} eq 'dropdb') {
		&DropDB($in{db});
		print "Location: action.cgi\n\n";
	}
	elsif ($in{q} eq 'createtbl') {
	
		$res = qq^
			<center>Create table: $in{db}</center><br>
			<form action="action.cgi" method="post">
				<input type="hidden" name="q" value="createtbl2">
				<input type="hidden" name="db" value="$in{db}">
				Table Name:<br>
				<input type="text" name="tblname">
				<br>
				Fields: <small>(separated by comma)</small><br>
				<input type="text" name="fields">
				<input type="Submit">
			</form>
		^;
		
	}
	elsif ($in{q} eq 'createtbl2') {
		&CreateTable($in{db}, $in{tblname}, [split(/,/, $in{fields})]);
		print "Location: action.cgi?db=$in{db}\n\n";	
	}
	elsif ($in{q} eq 'edittbl') {
		$res = &EditTbl;
	}
	elsif ($in{q} eq 'droptbl') {
		&DropTable($in{db}, $in{tbl});
		print "Location: action.cgi?db=$in{db}\n\n";
	}
	elsif ($in{q} eq 'restructure') {
		$res = &ShowRestructureForm;
	}
	elsif ($in{q} eq 'delfields') {
		$res = &DeleteFields;
	}
	elsif ($in{q} eq 'addfields') {
		$res = &AddFields;
	}
	elsif ($in{q} eq 'compresstbl') {
		$res = &CompressTbl;
	}
	elsif ($in{q} eq 'addrec') {
		$res = &AddRec;
	}
	elsif ($in{q} eq 'addrec2') {
		$res = &AddRec2;
	}
	elsif ($in{q} eq 'delrec') {
		$res = &DelRec;
	}
	elsif ($in{q} eq 'editrec') {
		$res = &EditRec;
	}
	elsif ($in{q} eq 'editrec2') {
		$res = &EditRec2;
	}
	elsif ($in{q} eq 'execquery') {
		$res = &ExecQuery;
	}
	elsif ($in{q} eq 'execquery2') {
		$res = &ExecQuery2;
	}
	#elsif ($in{q} eq '') {
	#elsif ($in{q} eq '') {
	#elsif ($in{q} eq '') {
	else {};
	
	return $res;
};


sub	ExecQuery {
	my $db = $in{db} || return "no db specified";
	
	my $d = qq^
		<br><center>Database: $db</center><br><hr>
		Query:<br>
		<form action="action.cgi" method="post">
			<input type="hidden" name="q" value="execquery2">
			<input type="hidden" name="db" value="$db">
			<textarea name="query" rows=10 cols=60></textarea><br>
			<input type="submit" value="Execute Query">
		</form>
	^;	
	
	return $d;
};

sub	ExecQuery2 {
	my $db_from = $in{db} || return "no db specified";
	
	my $d = qq^
		<br><center>Database: $db_from</center><br><hr>
		Query:<br><hr> <i>$in{query}</i> <hr> Result:<br>
	^;
	
	my $db = New LKDatabase($in{db});
	my $dbn = $db->Query($in{query});
	
	my $res;
	
	if (! $dbn) {
		$res .= join('<br>', @{$db->{'ERRORS'}});
		goto Final;
	};
	
	$db = $dbn;
	
	if ($in{query} !~ /^select/i){
		$res .= 'OK';
		goto Final;
	} else {
		$res .= 'Records selected: ' . $db->{RecordCount} . '<br>';
	};
	
	my $nl = "\n";
	$res .= $nl . '<table border=1>' . $nl;

	# make header
	$res .= '<tr>' .$nl;
	for (my $i=0; $i < scalar @{$db->{Fields}}; $i++){
		$res .= '<td>' . $db->{Fields}->[$i] . '</td>' . $nl;
	};
	$res .= '</tr>' . $nl x 2;	
	
	#Data
	do {
		$res .= '<tr>';
		for (my $i=0; $i < scalar @{$db->{Fields}}; $i++){
			$res .= '<td>' . $db->{FieldByName}->{ $db->{Fields}->[$i] } . '</td>' . $nl;
		};
		
		$res .= '</tr>' . $nl x 2;
	} while $db->Next;	
	
	$res .= '</table>' . $nl x 4;

	Final:
	$db->Close;
	$d .= $res;	
	
	return $d;
};


# print edit form
sub	EditRec {
	my $res = "<center>Editing record ($in{rec_nom}): $in{db} -> $in{tbl}</center><br>";

	my $db = New LKDatabase($in{db});
	$db->Open($in{tbl});
	
	my $pfbn = $db->{ParseFieldByName};
	$db->{ParseFieldByName} = {};
	for (my $i=0; $i < $in{rec_nom}; $i++) {$db->Next};
	$db->{ParseFieldByName} = $pfbn;
	$db->ReadRec;
	
	$res .= qq^
		<form action="action.cgi" method="post">
			<input type="Hidden" name="q" value="editrec2">
			<input type="Hidden" name="rec_nom" value="$in{rec_nom}">
			<input type="Hidden" name="tbl" value="$in{tbl}">
			<input type="Hidden" name="db" value="$in{db}">
	^;
	
	foreach ( @{$db->{Fields}} ){
		$res .= qq^
			$_ : <br>
			<textarea name="$_">$db->{FieldByName}->{$_}</textarea><br>
		^;
	};
		
	$res .= q^
		<input type="Submit">
		</form>
	^;
	
	$db->Close;
	return $res;
};

# used to update data
sub	EditRec2 {
	my $db = New LKDatabase($in{db});
	$db->Open($in{tbl});
	
	my $pfbn = $db->{ParseFieldByName};
	$db->{ParseFieldByName} = {};
	for (my $i=0; $i < $in{rec_nom}; $i++) {$db->Next};
	$db->{ParseFieldByName} = $pfbn;
	$db->ReadRec;
	
	$db->Edit;
	
	foreach ( @{$db->{Fields}} ){
		$db->{FieldByName}->{$_} = $in{$_};
	};
	
	$db->Post;
	$db->Close;	
	print "Location: action.cgi?q=edittbl&tbl=$in{tbl}&db=$in{db}\n\n";
};



# used to del $in{rec_nom} record
sub	DelRec {
	my $db = New LKDatabase($in{db});
	$db->Open($in{tbl});
	
	$db->{ParseFieldByName} = {};
	for (my $i=0; $i < $in{rec_nom}; $i++) {$db->Next};
	$db->Delete;
	$db->Close;
	print "Location: action.cgi?q=edittbl&tbl=$in{tbl}&db=$in{db}\n\n";	
};


# add record to db
sub	AddRec2 {
	my $db = New LKDatabase($in{db});
	$db->Open($in{tbl});
	
	$db->Append;
	
	foreach ( @{$db->{Fields}} ){
		$db->{FieldByName}->{$_} = $in{$_};
	};
	
	$db->Post;
	$db->Close;	
	print "Location: action.cgi?q=edittbl&tbl=$in{tbl}&db=$in{db}\n\n";
};


# print Addrec form
sub	AddRec {
	my $res = "<center>Add record : $in{db} -> $in{tbl}</center><br>";

	my $db = New LKDatabase($in{db});
	$db->Open($in{tbl});
	
	$res .= qq^
		<form action="action.cgi" method="post">
			<input type="Hidden" name="q" value="addrec2">
			<input type="Hidden" name="tbl" value="$in{tbl}">
			<input type="Hidden" name="db" value="$in{db}">
	^;
	
	foreach ( @{$db->{Fields}} ){
		$res .= qq^
			$_ : <br>
			<textarea name="$_"></textarea><br>
		^;
	};
		
	$res .= q^
		<input type="Submit">
		</form>
	^;
	
	$db->Close;
	return $res;
};


sub	ShowRestructureForm {

	my $db = New LKDatabase($in{db});
	$db->Open($in{tbl});
	my $flds = join('<br>', @{$db->{Fields}});
	$db->Close;

	my $res = qq^
		<center>Restructure table: $in{db} -> $in{tbl}</center><br>
		Fields:<br><hr> $flds <br><hr>
		
		<form action="action.cgi" method="post">
			<input type="hidden" name="q" value="delfields">
			<input type="hidden" name="db" value="$in{db}">
			<input type="hidden" name="tbl" value="$in{tbl}">

			Delete Fields: <small>(separated by comma)</small><br>
			<input type="text" name="fields">
			<input type="Submit" value="Delete Fields">
		</form>
		<form action="action.cgi" method="post">
			<input type="hidden" name="q" value="addfields">
			<input type="hidden" name="db" value="$in{db}">
			<input type="hidden" name="tbl" value="$in{tbl}">

			Add Fields: <small>(separated by comma)</small><br>
			<input type="text" name="fields">
			<input type="Submit" value="Add Fields">
		</form>		
	^;
	
	return $res;
};


# Edit Table form $in{db} -> $in{tbl}
sub	EditTbl {
	my $res = "<center>Table: $in{tbl}</center><br>";
	
	my $page = $in{page} || 0;
	$page *= 20;
	
	my $db = New LKDatabase($in{db});
	$db->Open($in{tbl});
	my $records = $db->RecordCount;
	my $deleted_count = $db->{DeletedCount};
	$db->Close;
	
	$res .= qq~
		Deleted records / Total : $deleted_count / $records<br>
		<a href="action.cgi?q=restructure&db=$in{db}&tbl=$in{tbl}">Restructure Table</a><br>
		<a href="action.cgi?q=droptbl&db=$in{db}&tbl=$in{tbl}">Drop Table</a><br>
		<a href="action.cgi?q=compresstbl&db=$in{db}&tbl=$in{tbl}">Compress Table</a><br>
		<hr>
		<a href="action.cgi?q=addrec&db=$in{db}&tbl=$in{tbl}">Add Record</a><br>
	~;	
	
	my $NumOfPages = int(($records+19)/20);
	$NumOfPages-- if $NumOfPages > 0;
	
	$res .= '<br>' x 2 . 'Pages: ';
	
	my $divider = 0;
	
	foreach ( (0..$NumOfPages) ){
	
		$divider++;
		if ($divider >= 10) {
			$res .= '<br>';
			$divider = 0;
		};
		
		if ($_ eq ($page/20)){
			$res .= $_ . '|';
		} else {
			$res .= qq^<a href="action.cgi?q=edittbl&tbl=$in{tbl}&db=$in{db}&page=$_">$_</a>^ . '|';
		};
	};
	
	chop($res);	# del '|'
	
	$db = $db->Query(qq^SELECT * FROM $in{tbl} LIMIT $page,20^);
	
	$res .= '<br>' x 3;
	my $nl = "\n";
	$res .= $nl . '<table border=1>' . $nl;

	# make header
	$res .= '<tr>' .$nl;
	for (my $i=0; $i < scalar @{$db->{Fields}}; $i++){
		$res .= '<td>' . $db->{Fields}->[$i] . '</td>' . $nl;
	};
	$res .= '<td>Edit/Delete</td>' . $nl;
	$res .= '</tr>' . $nl x 2;
	
	my $rec_nom = $page;
	
	#Data
	do {
		$res .= '<tr>';
		for (my $i=0; $i < scalar @{$db->{Fields}}; $i++){
			$res .= '<td>' . $db->{FieldByName}->{ $db->{Fields}->[$i] } . '</td>' . $nl;
		};
		$res .= qq^<td>
			<a href="action.cgi?q=editrec&tbl=$in{tbl}&db=$in{db}&rec_nom=$rec_nom">Edit</a>/<a href="action.cgi?q=delrec&tbl=$in{tbl}&db=$in{db}&rec_nom=$rec_nom">Delete</a>
		</td>^ . $nl;
		$res .= '</tr>' . $nl x 2;
		$rec_nom++;
	} while $db->Next;	
	
	$res .= '</table>' . $nl x 4;

	$db->Close;
	
	return $res;
};



sub	AddFields {
	&AlterFields('a');
};

sub	DeleteFields {
	&AlterFields('d');
};

sub	CompressTbl {
	&AlterFields();
};

#1 ['a','d']	'a' - add, 'd' - del, '' - compress;
sub	AlterFields {
	my ($DoWhat) = @_;
	
	my $db = New LKDatabase($in{db});
	$db->Open($in{tbl});
	
	my @NewFields;
	
	if ($DoWhat eq 'a') {
		# add all plus
		push(@NewFields, @{$db->{Fields}});
		my %NowFields = map {$_ => '1'} @NewFields;
		foreach ( split(/,/, $in{fields}) ){
			push(@NewFields, $_) unless $NowFields{$_};
			$NowFields{$_} = 1;
		};
		
	} elsif ($DoWhat eq 'd') {
		#add all except ...
		foreach (@{$db->{Fields}}){
			push(@NewFields, $_) unless $in{fields} =~ /\Q$_\E/;
		};
		
	} else {
		# just compress
		push(@NewFields, @{$db->{Fields}});
	};
	
	#make temp table
	my $tblName = &GetQueryTableName();	
	&CreateTable($in{db}, $tblName, \@NewFields);
	my $new_db = New LKDatabase($in{db});
	$new_db->Open($tblName);
	
	$db->First || goto goClose;
	
	do{
		$new_db->Append;
		$new_db->{FieldByName} = $db->{FieldByName};
		$new_db->Post;
	} while $db->Next;
	
	goClose:

	$db->Close;
	$new_db->Close;
	
	#delete old
	&DropTable($in{db}, $in{tbl});
	
	#rename tbl
	&LockFile("$path/$Database_dir/$in{db}/$in{db}.lkdb.lock");	
	open(DB, "<$path/$Database_dir/$in{db}/$in{db}.lkdb");
	flock(DB, 2) if $Use_flock;
	my %tbls = map {$_ => ''} split(/,/, <DB>);
	flock(DB, 8) if $Use_flock;
	close(DB);

	#delete temp
	delete $tbls{$tblName};
	# define old
	$tbls{$in{tbl}} = '';
	
	open(DB, ">$path/$Database_dir/$in{db}/$in{db}.lkdb");
	flock(DB, 2) if $Use_flock;
	my $tbls_str = join(',', keys %tbls);
	$tbls_str .= ',' if $tbls_str !~ /,$/;
	print DB $tbls_str;
	flock(DB, 8) if $Use_flock;
	close(DB);	
	&UnLockFile("$path/$Database_dir/$in{db}/$in{db}.lkdb.lock");

	# rename physically
	rename ("$path/$Database_dir/$in{db}/$tblName.def", "$path/$Database_dir/$in{db}/$in{tbl}.def");
	rename ("$path/$Database_dir/$in{db}/$tblName.tbl", "$path/$Database_dir/$in{db}/$in{tbl}.tbl");
	rename ("$path/$Database_dir/$in{db}/$tblName.tbld", "$path/$Database_dir/$in{db}/$in{tbl}.tbld");

	print "Location: action.cgi?q=edittbl&db=$in{db}&tbl=$in{tbl}\n\n";
};


1;