sub	Max {
if ($_[0] > $_[1]) { return $_[0]; } else { return $_[1]; };
};
sub	Min {
if ($_[0] > $_[1]) { return $_[1]; } else { return $_[0]; };
};
sub	EvalCode {
my ($Code) = @_;
return 1 if !$Code;
my $res = eval($Code);
return ($@?'':$res);
};
sub	Escape {
my ($text) = @_;
$text =~ s/([^a-zA-Z0-9_\-. ])/uc sprintf("%%%02x",ord($1))/eg;
$text =~ tr/ /+/;	# spaces become pluses
return $text;
};
sub UnEscape {
my($text) = @_;
$text =~ tr/+/ /;	# pluses become spaces
$text =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
return $text;
};
sub	Struct2Text {
my ($Struct, $Store_empty_values) = @_;
sub	safe {
my($toencode) = @_;
$toencode =~ s/([;,% \\"'\[\]\x00-\x1F])/uc sprintf("%%%02x",ord($1))/eg;
return $toencode;
};
$Store_empty_values = 0 unless defined $Store_empty_values;
my $res = '';
if (ref($Struct) eq "SCALAR") {
$res = "/'" . &safe(${$Struct}) . "'";
} elsif (ref($Struct) eq "ARRAY") {
$res = "[";
foreach (@{$Struct}) { $res .= &safe(&Struct2Text($_, $Store_empty_values)) . ","; };
chop $res;
$res .= "]";
} elsif (ref($Struct) eq "HASH") {
$res = "{";
foreach (keys %{$Struct}) { $res .= "'" . &safe($_) . "'=>" . &safe(&Struct2Text(${$Struct}{$_}, $Store_empty_values)) . "," if (${$Struct}{$_} || $Store_empty_values); };
chop $res;
$res .= "}";
} elsif (ref($Struct) eq "REF") {
$res = "\'" . &safe(&Struct2Text(${$Struct}, $Store_empty_values)) . "'";
} else {
$res = "'" . &safe($Struct) . "'";
};
return $res;
};
sub Text2Struct {
my ($Text) = @_;
my $res;
sub unsafe {
my ($todecode) = @_;
$todecode =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
return $todecode;
};
my $fl = substr($Text, 0, 1);
if ($Text =~ m/^\/'(.*)'$/is) { # SCALAR
$res = \&unsafe($1);
} elsif ($Text =~ m/^\[(.*)\]$/is) { # ARRAY
my $idx=0;
foreach (split(/\s*,\s*/,$1)) { ${$res}[$idx++] = &Text2Struct(&unsafe($_)); };
} elsif ($Text =~ m/^\{(.*)\}$/is) { # HASH
foreach (split(/\s*,\s*/,$1)) {
if (m/'(.*?)'=>(.*)/is) {
my ($var, $val) = ($1, $2);
${$res}{&unsafe($var)} = &Text2Struct(&unsafe($val));
};
};
} elsif ($Text =~ m/^\\'(.*)'$/is) { # REF
$res = \&Text2Struct(&unsafe($1));
} elsif ($Text =~ m/^'(.*)'$/is) { # NOT REF
$res = &unsafe($1);
};
return $res;
};
sub     SafeHTMLTag {
my ($input) = @_;
$input =~ s/&/&amp;/g;
$input =~ s/\</&lt;/g;
$input =~ s/\>/&gt;/g;
$input =~ s/\"/&quot;/g;
$input =~ s/\cM//g;
return $input;
};
1;
