require "$path/LKBinTbl.pl";
require "$path/LKBinDB.pl";
require "$path/LKSQLfunc.pl";
package LKDatabase;
sub	ExecQuery {
my ($self, $Query) = @_;
$Query =~ s/.\n/ /sg;	
return $self->SelectQuery($Query) if $Query =~ /^select/i;
return $self->DeleteQuery($Query) if $Query =~ /^delete/i;
return $self->InsertQuery($Query) if $Query =~ /^insert/i;
return $self->UpdateQuery($Query) if $Query =~ /^update/i;
return $self->_ERROR("Query not suppoted:\n$Query\n\n");
};
sub	Query { return $_[0]->ExecQuery($_[1]); };
sub	DeleteQuery {
my ($self, $Query) = @_;
$Query =~ /^delete from (.*?) where (.*?)$/i;
my ($Tbl_name, $Statemant) = ($1, $2);
my $DB;
my $is_opened_here = 0;
if ($self->{Table} eq $Tbl_name){
$DB = $self;
if (!$DB->{IsOpen}){
$DB->Open($DB->{Table}) || return '';
$is_opened_here = 1;
};
}else{
$DB = LKDatabase->New($self->{DB});
$DB->Open($Tbl_name) || return '';
$is_opened_here = 1;
};	
my $IfStatemant = &::BuildIfStatemant('$DB', $Statemant);
my $UsedFields = &::GetUsedFields('$DB', $IfStatemant);
my %ParseFieldByName = %{$DB->{ParseFieldByName}};	#save
foreach my $fld_name ( keys %{$DB->{ParseFieldByName}} ){
$DB->{ParseFieldByName}->{$fld_name} = 0;
};
foreach my $fld_name ((@{$UsedFields}, split(/,/, $Fields))) {
$DB->{ParseFieldByName}->{$fld_name} = 1;
};
my $CurrentOffset = 0;
my $RowsDeleted = 0;	
eval{
$DB->First || goto TheEnd;
do{
EV:{
if ( eval($IfStatemant) ) {
if ($DB->Delete) {
redo EV;
};	
};
};
} while $DB->Next;
TheEnd:
};
$DB->{ParseFieldByName} = \%ParseFieldByName;	# restore prev
$DB->First;
$DB->Close if $is_opened_here;
return $DB;	
};
sub	SelectQuery {
my ($self, $Query) = @_;
my $IsSimpleQuery = 0;	# query with 'WHERE' ?
my ($Fields, $Tbl_name, $Statemant, $LimitOffset, $LimitRows, $New_tbl_name);
if ( $Query =~ /^SELECT (.*?) FROM (.*?) WHERE (.*?) ?(?:LIMIT (?:(\d+)\,)?(\d+))?$/i ){
($Fields, $Tbl_name, $Statemant, $LimitOffset, $LimitRows) = ($1, $2, $3, $4, $5);
} else {
$IsSimpleQuery = 1;
$Query =~ /^SELECT (.*?) FROM (.*?) ?(?:LIMIT (?:(\d+)\,)?(\d+))?$/i;
($Fields, $Tbl_name, $LimitOffset, $LimitRows) = ($1, $2, $3, $4);
};
my $CurrentOffset = 0;
my $RowsSelected = 0;	
my $DB;
my $is_opened_here = 0;
if ($self->{Table} eq $Tbl_name){
$DB = $self;
if (!$DB->{IsOpen}){
$DB->Open($DB->{Table}) || return '';
$is_opened_here = 1;
};
}else{
$DB = LKDatabase->New($self->{DB});
$DB->Open($Tbl_name) || return '';
$is_opened_here = 1;
};
if ($Fields =~ /^(?:all|\*)$/i) {
$Fields = join(',', @{$DB->{Fields}});
} else {
my @tmp = split(/,/, $Fields);
foreach (@tmp) { s/^[\s\n]*((?:.|\n)*?)[\s\n]*$/$1/; };
$Fields = join(',', @tmp);
};
my $QDB;
my $Into_Set = 0;
$New_tbl_name = &::GetQueryTableName($DB->{DB});
&::CreateTable($DB->{DB}, $New_tbl_name, [split(/,/, $Fields)]) || return '';
$QDB = LKDatabase->New($DB->{DB}) || return '';
$QDB->{IsTemp} = 1;
$QDB->Open($New_tbl_name) || return '';
my ($IfStatemant, $UsedFields) = ('', []);
if (!$IsSimpleQuery){
$IfStatemant = &::BuildIfStatemant('$DB', $Statemant);
$UsedFields = &::GetUsedFields('$DB', $IfStatemant);
};	
my %ParseFieldByName = %{$DB->{ParseFieldByName}};	#save
foreach my $fld_name ( keys %{$DB->{ParseFieldByName}} ){
$DB->{ParseFieldByName}->{$fld_name} = 0;
};
foreach my $fld_name ((@{$UsedFields}, split(/,/, $Fields), split(/,/, $OrderBy))) {
$DB->{ParseFieldByName}->{$fld_name} = 1;
};
$DB->First || goto TheEnd;
Redo:{
do{
my $res = 0;
if ($IsSimpleQuery){
$res = 1;
} else {
$res = eval($IfStatemant);
};
if ( $res ) {
if ($LimitOffset ne '' && $CurrentOffset < $LimitOffset ) { 
$CurrentOffset++;
last Redo unless $DB->Next;
goto Redo;
};
$QDB->Append;
%{$QDB->{FieldByName}} = %{$DB->{FieldByName}};
$QDB->Post;
$RowsSelected++;
last Redo if ($LimitRows ne '' && $RowsSelected >= $LimitRows);
};
} while $DB->Next;
};
TheEnd:
$DB->{ParseFieldByName} = \%ParseFieldByName;	# restore prev
$DB->Close if $is_opened_here;
if ($Into_Set){
$QDB->Close;
} else {	
$QDB->First;
};
return $QDB;
};
sub	InsertQuery {
my ($self, $Query) = @_;
my ($Tbl_name, $Fields, $Values, @Fields, @Values);
if ( $Query =~ /^INSERT INTO (.*?) SET (.*?)$/i ){
($Tbl_name, $SetData) = ($1, $2);
foreach my $pair ( split(/,/, $SetData) ){
$pair =~ /^\s*(.*?)\s*=\s*(.*)\s*$/;
push(@Fields, $1);
push(@Values, $2);
};
} else { return 0 };
foreach (@Values) { 
s/^[\s\n]*((?:.|\n)*?)[\s\n]*$/$1/;		#trim
s/^\'((?:.|\n)*)\'$/$1/i;	# del \'
};	
my $DB;
my $is_opened_here = 0;
if ($self->{Table} eq $Tbl_name){
$DB = $self;
if (!$DB->{IsOpen}){
$DB->Open($DB->{Table}) || return '';
$is_opened_here = 1;
};
}else{
$DB = LKDatabase->New($self->{DB});
$DB->Open($Tbl_name) || return '';
$is_opened_here = 1;
};
$DB->Append;
$DB->{FieldByName} = {};	# clear
for (my $i=0; $i <= scalar @Fields -1; $i++){
$DB->{FieldByName}->{$Fields[$i]} = $Values[$i];
};
$DB->Post;
$DB->Close if $is_opened_here;
return 1;
};
sub	UpdateQuery {
my ($self, $Query) = @_;
return $self->_ERROR("Query not suppoted:\n$Query\n\n") unless $Query =~ /^UPDATE (.*?) SET (.*?) WHERE (.*?)$/i;	
my ($Tbl_name, $SetFields, $Statemant) = ($1, $2, $3);
my $DB;
my $is_opened_here = 0;
if ($self->{Table} eq $Tbl_name){
$DB = $self;
if (!$DB->{IsOpen}){
$DB->Open($DB->{Table}) || return '';
$is_opened_here = 1;
};
}else{
$DB = LKDatabase->New($self->{DB});
$DB->Open($Tbl_name) || return '';
$is_opened_here = 1;
};
my $IfStatemant = &::BuildIfStatemant('$DB', $Statemant);
my $UsedFields = &::GetUsedFields('$DB', $IfStatemant);
my %ParseFieldByName = %{$DB->{ParseFieldByName}};	#save
foreach my $fld_name ( keys %{$DB->{ParseFieldByName}} ){
$DB->{ParseFieldByName}->{$fld_name} = 0;
};
foreach my $fld_name ( @{$UsedFields} ) {
$DB->{ParseFieldByName}->{$fld_name} = 1;
};
eval{
$DB->First || goto TheEnd;
my %ParseFieldByName2 = %{$DB->{ParseFieldByName}};	#save
do{
if ( eval($IfStatemant) ) {			
$DB->{ParseFieldByName} = \%ParseFieldByName;	# restore prev
$DB->ReadRec; # reparse ALL fields
$DB->Edit;
foreach my $pair ( split(/,/, $SetFields) ){
$pair =~ /^\s*(.*?)\s*=\s*(.*)\s*$/;
my($key, $val) = ($1, $2);
$val =~ s/^[\s\n]*((?:.|\n)*?)[\s\n]*$/$1/;		#trim
$val =~ s/^\'((?:.|\n)*)\'$/$1/i;	#del \'
$DB->{FieldByName}->{$key} = $val;
};
$DB->Post;
$DB->{ParseFieldByName} = \%ParseFieldByName2;	# restore prev2				
};
} while $DB->Next;
TheEnd:
};
$DB->{ParseFieldByName} = \%ParseFieldByName;	# restore prev
$DB->Close if $is_opened_here;
return 1;		
};
1;