require "$path/StrFunc.pl";
sub	GetUsedFields {
my ($ObjName, $SQLStatemant) = @_;
my @UsedFields;
while ($SQLStatemant =~ /(\Q$ObjName\E\Q->{FieldByName}->{\E([a-z_0-9]+)\})/i){
push(@UsedFields, $2);
$SQLStatemant =~ s/\Q$1\E//;
};
return \@UsedFields;
};
sub	BuildIfStatemant {
my ($ObjName, $SQLStatemant) = @_;
return '' unless $SQLStatemant;
local %StrConsts;
$SQLStatemant = &SQLEncodeStrings($SQLStatemant, \%StrConsts);	
my $res;
if ($SQLStatemant =~ /[\)\(]/){
$SQLStatemant =~ s/^\((.*)\)$/$1/;	# del first ald last () if nothing outside
my $Level = 0;
my %LevelData;
my @TreePath;
my $CurStr;
for (my $i=0; $i < length($SQLStatemant); $i++){
my $symb = substr($SQLStatemant, $i, 1);
$LevelData{$Level} = [] unless defined $LevelData{$Level};	# make free
if ( $symb eq '(' ){
push( @{$LevelData{$Level}}, $CurStr );
push( @TreePath, "$Level." . scalar @{$LevelData{$Level}} - 1 );
$Level++;
$CurStr = '';
}
elsif ( $symb eq ')' ){
push( @{$LevelData{$Level}}, $CurStr );
push( @TreePath, "$Level." . scalar @{$LevelData{$Level}} - 1 );
$Level--;
$CurStr = '';
} else {
$CurStr .= $symb;
};
};
$Level = 0;
while ( defined $LevelData{$Level} ){
for ( my $i=0; $i < scalar @{$LevelData{$Level}}; $i++){
$LevelData{$Level}->[$i] = &ProcessSimpleQuery($ObjName, $LevelData{$Level}->[$i]);
};
$Level++;
};
$SQLStatemant = '';
$Level = 0;
for (my $i=0; $i < scalar @TreePath; $i++){
my ($NewLev, $id) = split( /\./, $TreePath[$i] );
if ($NewLev > $Level) {
$Level = $NewLev;
$SQLStatemant .= '(';
}
elsif ($NewLev < $Level){
$Level = $NewLev;
$SQLStatemant .= ')';
};
$SQLStatemant .= $LevelData{$Level}->[$id];
};
$SQLStatemant .= ')' if $Level;
$SQLStatemant = '(' . $SQLStatemant . ')';
} else {
$SQLStatemant = &BuildSimpleIfStatemant($ObjName, $SQLStatemant);
};
$res = &SQLDecodeStrings($SQLStatemant, \%StrConsts);	
return $res;
};
sub	ProcessSimpleQuery {
my ($ObjName, $Query) = @_;
$Query =~ s/and/\&\&/ig;
$Query =~ s/or/\|\|/ig;
my ($bef_op, $af_op, $op);
$Query =~ /^\s*(..)\s+/;	$op = $1;
if ($op eq '&&' || $op eq '||'){
$bef_op = $op;
$Query =~ s/^\s*..\s+(.*)$/$1/;
};
$Query =~ /.*\s+(..)\s*$/;	$op = $1;
if ($op eq '&&' || $op eq '||'){
$af_op = $op;
$Query =~ s/^(.*)\s+..\s*$/$1/;
};
return $bef_op . ' ' . &BuildSimpleIfStatemant($ObjName, $Query) . ' '. $af_op;			
};
sub	BuildSimpleIfStatemant {
local ($ObjName, $SQLStatemant) = @_;
local (%Statemants, %StOper);
local $i = 1;
sub	GetOp {
my ($Template) = @_;
my ($op1, $op2);
if ($Statemants{$i}->{1} =~ /^\'?\$_VAR\d+\'?$/){
$op1 = $Statemants{$i}->{1};
} else {
(my $key = $Statemants{$i}->{1}) =~ s/^\'?(.*)\'?$/$1/;
$op1 = $ObjName . '->{FieldByName}->{' . $key . '}';
};
if ($Statemants{$i}->{2} =~ /^\'?\$_VAR\d+\'?$/){
$op2 = $Statemants{$i}->{2};
} else {
(my $key = $Statemants{$i}->{2}) =~ s/^\'?(.*)\'?$/$1/;
$op2 = $ObjName . '->{FieldByName}->{' . $key . '}';
};
$Template =~ s/\$V_1/$op1/;
$Template =~ s/\$V_2/$op2/;
return $Template;
};
while (1){
last if !($SQLStatemant =~ /^\s*(([a-z_0-9\$\']+)\s*((?:[!=~><]|like)+)\s*([a-z_0-9\$\']+))(.*)$/i);
$Statemants{$i}->{1} = &Trim($2);
$Statemants{$i}->{2} = &Trim($4);
$Statemants{$i}->{op} = &Trim($3);
$SQLStatemant =~ s/^\s*\Q$1\E//;
$SQLStatemant = &Trim($SQLStatemant);
if ($SQLStatemant) {
return '' unless $SQLStatemant =~ /^\s*(([a-z_0-9\|\&]+)\s*)(.*)$/i;
$StOper{$i} = $2;
$SQLStatemant =~ s/^\Q$1\E//;  
};
$i++;
};
my $res;
$i = 1;	
while (1){
last unless defined $Statemants{$i};
$_ = $Statemants{$i}->{op};
S: {
if (/^={1,2}$/) { $res .= &GetOp(' $V_1 eq $V_2 '); last S;};
if (/^(?:!=|<>)$/) { $res .= &GetOp(' $V_1 ne $V_2 '); last S;};
if (/^(>=|<=|>|<)$/) { $res .= &GetOp(' $V_1 ' . $1 . ' $V_2 '); last S;};
return '';	#	error in query
};
if ( $StOper{$i} ) {
my $pl_op = &Trim($StOper{$i});
K:{
if ( $pl_op =~ /^and$/i ) { $pl_op ='&&'; last K; };
if ( $pl_op =~ /^or$/i ) { $pl_op ='||'; last K; };
};
$res .= ' ' . $pl_op . ' ';
};
$i++;
};
return $res;
};
sub	SQLEncodeStrings {
my ($SQLQuery, $SaveToHash) = @_;
my $i = 0;
while ( $SQLQuery =~ /^(.*)\'([^\']*)\'(.*)$/ ){
$SaveToHash->{$i} = $2;
my $rep_to = $1 . '$_VAR' . $i . $3;
$SQLQuery =~ s/^\Q$1\E\'\Q$2\E\'\Q$3\E$/$rep_to/;
$i++;
};
$SQLQuery =~ s/([^\']?)(\$_VAR\d+)([^\']?)/$1\'$2\'$3/g;	
return $SQLQuery;
};
sub	SQLDecodeStrings {
my ($SQLQuery, $LoadFromHash) = @_;
$SQLQuery =~ s/\$_VAR(\d+)/$LoadFromHash->{$1}/g;
return $SQLQuery;
};
sub	GetQueryTableName {
my ($DbName) = @_;
my $i = 1;
$i++ while (-e "$path/$Database_dir/$DbName/TEMP_$i.def");
return "TEMP_$i";
};
1;