#!/usr/bin/perl5
{
if (defined $in{lang} && -e "$path/${::TemplatesDir}.$in{lang}"){
$::TemplatesDir = "${::TemplatesDir}.$in{lang}";
};
};
require "$path/File.pl";
require "$path/GenFunc.pl";
%TemplatesProcessors =(
'Description' => \&ProcessDescription,
'Scalars' => \&ProcessScalars,
'Code' => \&ProcessCode,
'Loops' => \&ProcessLoops,
);
@ProcessorsPriority = (
'Description' => 'Scalars' => 'Code' => 'Loops',
);
%DenyProcessors = {};
sub	PT { &ProcessTemplate; };
sub	ProcessTemplate {
my ($Tepmlate, $Values, $IsAbsPath) = @_;
$IsAbsPath = 0 unless defined $IsAbsPath;
my $FN;
if ($IsAbsPath){
$FN = $Tepmlate;
}else{
local $TemplatesDir = $::TemplatesDir || 'Templates';
my $tmpfn = "$TemplatesDir/$Tepmlate";
$FN = (-e $tmpfn?$tmpfn:(-e "$tmpfn.htmlt"?"$tmpfn.htmlt":''));
};
return '' if !-e $FN;
my $TemplateData = &ReadFile($FN);
return &ProcessText($TemplateData, $Values);
};
sub	ProcessText {
my ($Text, $Values) = @_;
for (my $i=0; $i < scalar @ProcessorsPriority; $i++){
next if defined $DenyProcessors{$ProcessorsPriority[$i]};
$Text = &{$TemplatesProcessors{$ProcessorsPriority[$i]}}($Text, $Values);
};
return $Text;
};
sub	FinalPrint {
my ($Text) = @_;
print $Expires_str if ($ENV{REQUEST_METHOD} ne "POST"); # To prevent page caching
print "Content-type: text/html\n\n";
print $Text;
exit;
};
sub	FinalRedirect {
my ($RedirectMsg, $RedirectDelay, $RedirectURL) = @_;
$RedirectMsg = $main::RedirectMsg unless defined $RedirectMsg;
$RedirectDelay = $main::RedirectDelay unless defined $RedirectDelay;
$RedirectURL = $main::RedirectURL unless defined $RedirectURL;
my $Values = {
'REDIRECT_MESSAGE' => $RedirectMsg,
'REDIRECT_DELAY' => $RedirectDelay,
'REDIRECT_URL' => $RedirectURL,
};
&FinalPrint( &ProcessTemplate("Redirect", $Values) );
};
sub     FP { &FinalProcess; };
sub	FinalProcess {
&FinalPrint( &ProcessTemplate );
};
sub     ProcessDescription {
my ($Text, $Values) = @_;
$Text =~ s/\<\-\-\!\!(?:(?:.|\s)+?)\!\!\-\-\>//gs;
return $Text;
};
sub	ProcessScalars {
my ($Text, $Values) = @_;
$Text =~ s/\<\-\-\$\$([A-Za-z\-_\.]+)\$\-\-\>/$Values->{$1}/gs;
return $Text;
};
sub	ProcessCode {
my ($Text, $Values) = @_;
local $NameSpace = $Values;
$Text =~ s/\<\-\-\%((?:.|\s)+?)\%\-\-\>/&EvalCode($1)/iegs;
$Text =~ s/\<\?perl((?:.|\s)+?)\?\>/&EvalCode($1)/iegs;
return $Text;
};
sub	ProcessLoops {
(my $Text, local $Values) = @_;
sub	LoopCode {
my ($Var, $Range, $Code) = @_;
my $Res;
$Range = ('0-' . scalar @{$Values->{$Var}} - 1) unless $Range;
$Range =~ s/^\[(.*)\]$/$1/;
if ( $Range =~ /^(\d*)?(?:\.\.|\-)(\d*)?$/ ){
my ($from, $to) = ($1 || 0, $2 || scalar @{$Values->{$Var}}-1);
for (my $i = $from; $i <= $to; $i++){
$_ = $Values->{$Var}->[$i];
my $ThisRes = $Code;
$ThisRes =~ s/\<\<(.+?)\>\>/eval($1)/ieg;
$Res .= $ThisRes;
};
}
elsif ( $Range =~ /\,/ || $Range =~ /^\d+$/ ) {
my @Numbers = split(/\,/, $Range);
foreach my $Numb ( @Numbers ) {
$_ = $Values->{$Var}->[$Numb];
my $ThisRes = $Code;
$ThisRes =~ s/\<\<(.+?)\>\>/eval($1)/ieg;
$Res .= $ThisRes;
};
};
return $Res;
};
$Text =~ s/\<\-\-\$LOOP\(\$([A-Za-z\-_\.]+)\)(\[[\d\-\.\,]+\])?((?:.|\s)+?)\$\-\-\>/&LoopCode($1, $2 ,$3)/iges;
return $Text;
};
1;
