#!c:\perl\bin\perl.exe
#!/usr/bin/perl
#!c:\perl\bin\perl.exe -d

$path = ".";  # Change this to full path to if you have problems.
chdir($1) if $0=~m/^(.*)[\/\\]/;

eval {
	# Load modules
	require "$path/project_const.inc";

    if  (-e (my $f = "$path/Config.pl")){
       require $f;
       &LoadConfig;
    };

	require "$path/InputParse.pl";
	&InputParse();
    require "$path/default.pl" if -e "$path/default.pl";

    require "$path/lang.pl"; # only after %in filled

    # optional modules
    require "$path/permissions.pl" if -e "$path/permissions.pl";
	require "$path/secure.pl" if -e "$path/secure.pl";
    require "$path/AdmAuth.pl" if -e "$path/AdmAuth.pl"; # need admin rights to use
};

##-----------------------------------------
sub	DieNow {

	sub Print505Error {
		print $Expires_str if ($ENV{REQUEST_METHOD} ne "POST"); # To prevent page caching
		print "Content-type: text/html\n\n"; 
		print "<HTML><HEAD><TITLE>505</TITLE><BODY><font size=+10>505 - script error</font><br><hr><br><br>$_[0]</BODY></HEAD></HTML>";
	};

	if  (-e (my $TmplPL = "$path/Templates.pl")){
		eval {
			require $TmplPL;
			&FinalProcess('505error', { 'Message' => $_[0] });
		};		
		if ($@) { &Print505Error; };
	} else {
		&Print505Error;
	};
};
##-----------------------------------------

if ($@) {
	print $Expires_str if ($ENV{REQUEST_METHOD} ne "POST"); # To prevent page caching
	my $msg = "Error including libraries:<br> $@\n<br>";
	$msg .= "Make sure they exist, permissions are set properly, and paths are set correctly.";
	
	&DieNow($msg);
	exit;
};


eval { &main(); };		# Trap any fatal errors so the program hopefully
if ($@) {				# never produces that nasty 500 server error page.
	print $Expires_str if ($ENV{REQUEST_METHOD} ne "POST"); # To prevent page caching
	my $msg = "fatal error:<br> $@\n<br>";

	&DieNow($msg);		
	exit;	
};
exit;


sub	main {
	my $action = $in{action};

	if ($action && $action !~ m/^\w+(\|\w+)?$/i) {
		if (defined &ExecutionDenied) {
			&ExecutionDenied($action);
		} else {
		   	die &GetLangVal('You do not able to execute this action') . ":<br>\n$action";
		};
	    exit;
	};

	$action = $::DefAction unless $action;
	
	BEGIN:

    # check permissions
    if (defined &CheckPermissions){
    	my $permit = &CheckPermissions($action);
		unless ($permit) {
			&ExecutionDenied($action);
			exit;
		};
	};

	my $Sub_Action = '';

	if ($action =~ m/\|/){
		($action, $Sub_Action) = split(/\|/, $action);
	};

	if (!-e "$path/$::ActionsDir/$action.pl"){
		if ($action eq $::DefAction) {
			die "File Not Found $::DefAction.pl";
		};

		$action = $::DefAction;
		$Sub_Action = undef;
		goto BEGIN;
	};

	require "$path/$::ActionsDir/$action.pl";

	my $SubName;

	if ($Sub_Action){
		$SubName = "${action}_$Sub_Action";
	} else {
		$SubName = "Action_$action";
	};

	eval { &$SubName(); };

	if ($@){
           if ($action ne $::DefAction){   # to avoid loop forever ...
	          $action = $::DefAction;
                  $Sub_Action = undef;
                  goto BEGIN;
           } else {
                  die "Error in ${action}.pl\n\n$@";
           };
        };

};

1;